% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in RtmpK6dyXN/file1e098811f04
\name{makeParamInfo}
\alias{makeParamInfo}
\title{Make an object of information about a model-parameter pairing for getParam.  Used internally}
\usage{
makeParamInfo(model, nodes, param)
}
\arguments{
\item{model}{A model such as returned by \code{\link{nimbleModel}}.}

\item{nodes}{A character string naming one one or more stochastic nodes, such as "mu", "c('mu', 'beta[2]')", or "eta[1:3, 2]".  getParam only works for one node at a time, but if it is indexed (nodes[i]), then makeParamInfo sets up the information for the entire vector nodes.  The processing pathway is used by the NIMBLE compiler.}

\item{param}{A character string naming a parameter of the distribution followed by node, such as "mean", "rate", "lambda", or whatever parameter names are relevant for the distribution of the node.}
}
\description{
Creates a simple getParam_info object, which has a list with a paramID and a type
}
\details{
This is used internally by \code{\link{getParam}}.  It is not intended for direct use by a user or even a nimbleFunction programmer.
}

